unit URTTI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure LoadPanel(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    KeyValue:Variant;
  published
    property pKeyValue:Variant read KeyValue write KeyValue;
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}
uses TypInfo;

procedure TForm1.Button1Click(Sender: TObject);
var cv:integer;
    lvTypeInfo:pTypeInfo;
    lvTypeData:pTypeData;
    lvPropInfo:pPropInfo;
    lvPropList:pPropList;
    lvObj:TObject;
    lvpObj:integer;
begin
  with Memo1 do
  Begin
    lvTypeInfo:=ClassInfo;
    lvTypeData:=GetTypeData(lvTypeInfo);
    if lvTypeData^.PropCount>0 then
    Begin
      GetMem(lvPropList,SizeOf(lvPropInfo)*lvTypeData^.PropCount);
      GetPropInfos(lvTypeInfo,lvPropList);
      for cv := 0 to lvTypeData^.PropCount-1 do
      begin
        if not (lvPropList[cv]^.PropType^.Kind=tkMethod) then
        Begin
          Memo1.Lines.Add(Format('%s : %s',[lvPropList[cv]^.Name,lvPropList[cv]^.PropType^.Name]));
          if lvPropList[cv]^.PropType^.Name='TColor' then
            Memo1.Lines.Add(Format('Value : %s',[ColorToString(GetPropValue(Memo1,lvPropList[cv]^.Name))]))
          else
          if lvPropList[cv]^.PropType^.Name='TCursor' then
            Memo1.Lines.Add(Format('Value : %s',[CursorToString(GetPropValue(Memo1,lvPropList[cv]^.Name))]))
          else
          Memo1.Lines.Add(Format('Value : %s',[GetPropValue(Memo1,lvPropList[cv]^.Name)]));
        End;
      end;
      FreeMem(lvPropList,SizeOf(lvPropInfo)*lvTypeData^.PropCount)
    End;
  End;
  lvObj:=FindComponent('Button1');
  SetPropValue(Self,'pKeyValue','Finished');
  SetPropValue(lvObj,'Caption',GetPropValue(Self,'pKeyValue'));
  SetPropValue(lvObj,'Enabled','false');
  lvObj:=FindComponent('Memo1');
  SetPropValue(lvObj,'Color',StringToColor('clBackground'));
  lvpObj:=GetPropValue(lvObj,'Font');
  SetPropValue(TObject(Pointer(lvpObj)),'Color',StringToColor('clWhite'));
end;

procedure TForm1.LoadPanel(Sender: TObject);
var FS:TFileStream;
    MS:TMemoryStream;
    RE:TReader;
    lvEnd:integer;
begin
  try
    FS:=TFileStream.Create('Panel.dfm',fmOpenRead);
    MS:=TMemoryStream.Create;
    ObjectTextToBinary(FS,MS);
    lvEnd:=0;
    MS.WriteBuffer(lvEnd,SizeOf(lvEnd));
    MS.Seek(0,soFromBeginning);
    RE:=TReader.Create(MS,4096);
    RE.ReadComponents(Self,Self,nil);
  finally
    FS.Free;
    MS.Free;
    RE.Free;
  end;
  Memo1.OnClick:=nil;
end;

Initialization
  RegisterClasses([TPanel,TButton]);

end.

